//#-------------------------------------------------------------------------------#
//# GENERATOR GPX souboru pro TrekBuddy v rozsahu PQ                              #
//# =================================================                             #
//#                                                                               #
//# GeoGet: http://geoget.ararat.cz/doku.php/start                                #
//#                                                                               #
//# Skript je mozno dale sirit a libovolne upravovat. Jedinou podminkkou je       #
//# uvedeni odkazu na puvodni skript.                                             #
//#                                                                               #
//# Umisteni souboru: ./GeoGet/data/script/TrekBuddy/TrekBuddy.gge.pas            #
//#-------------------------------------------------------------------------------#
//# Autor: Petr Ptacek                                                            #
//# Posledni aktualizace: 27.12.2010                                              #
//# Version: 2.4                                                                  #
//# Upravyl krteczek dne 24.11.2010                                               #
//# Copyright (c) 2010 Petr Ptacek                                                #
//#-------------------------------------------------------------------------------#
//#-------------------------------------------------------------------------------#

uses Trekbuddy_form; // Vlozime formular (jmeno souboru bez pripony)

{$INCLUDE TrekBuddy.form.pas } // Instrukce pro formular

var
  n: integer;

function ExportExtension: string;
begin
  Result := 'GPX';
end;

function ExportDescription: string;
begin
  result := 'TrekBuddy GPX Export (PQ)';
end;

function ExportHeader: string;
begin
  ShortExport; // Inicializace hodnot pro formular
  LongExport;  // Inicializace hodnot pro formular
  n := Trekbuddy_form.ShowModal; // Zobrazi formular a do n vrati zpusob ukonceni. Zde:
                                 // 1=Ok, 2=Cancel (nastavil jsem si to ve formulari)
  Result := '<?xml version="1.0" encoding="utf-8"?>' + CRLF;
  Result := Result + '<gpx xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0" creator="Groundspeak Pocket Query" xsi:schemaLocation="http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd http://www.groundspeak.com/cache/1/0 http://www.groundspeak.com/cache/1/0/cache.xsd" xmlns="http://www.topografix.com/GPX/1/0">' + CRLF;
  Result := Result + ' <desc>Geocache file generated by ' + Geoget_Version + '</desc>' + CRLF;
  Result := Result + ' <author>' + Geoget_Version + '</author>' + CRLF;
  Result := Result + ' <email>geby@mlp.cz</email>' + CRLF;
  Result := Result + ' <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', Now) + '</time>' + CRLF;
  Result := Result + ' <keywords>cache, geocache, groundspeak</keywords>' + CRLF + CRLF;  
end;

function ExportFooter: string;
begin
  result := '</gpx>' + CRLF;
end;

// Funkce pro zobrazeni uzivatelsky nastavitelneho vypisu nazvu bodu
function Selection(entry1: string; entry2: string; settings: integer): string;
begin
  case settings of
    0: result := '' + entry1  + '';
    1: result := '[' + entry2 + ']' + entry1 + ''; 
    2: result := '' + entry1 + ' [' + entry2 + ']'; 
    else result := '' + entry1  + '';
  end;
end;

// Funkce pro orez popisu
function TrimToLength(C: string; L: integer): string;
begin
 result := Copy(C,0,L);
end;

// Metoda odstranuje z textu HTML a diakritiku
function ToAscii(Text : string; Box : boolean) : string;
begin
  text := Html2Text(Text);
  if Box = true then begin
    Text := ReplaceString(Text, '°', 's');
    Text := UtfToAscii(Text);

  end;
  Result := Text;

end;

// Funkce pro vypis logu (prevzata z makra gpxgarmin; autoor medwyn_Cz)
function ExportLog(LogID,LogType,FinderID,Finder,Text :String; Date :TDateTime) : String;
var
  s : String;
begin
  Text := ToAscii(Text, True);

  s := '';
  if FinderID <> '' then
    s := ' id="' + FinderID + '"'; 

  Result := Result + '    <groundspeak:log id="' + LogID + '">' + CRLF;
  Result := Result + '     <groundspeak:date>' 
    + formatdatetime('yyyy"-"mm"-"dd', Date) + '</groundspeak:date>' + CRLF;  // Oficialni zapis casu 'yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz'
  Result := Result + '     <groundspeak:type><![CDATA[' + LogType + ']]></groundspeak:type>' + CRLF;
  Result := Result + '     <groundspeak:finder' + s + '><![CDATA[' + Finder + ']]></groundspeak:finder>' + CRLF;
  Result := Result + '     <groundspeak:text encoded="False"><![CDATA[' + Text + ']]></groundspeak:text>' + CRLF;
  Result := Result + '    </groundspeak:log>' + CRLF;
end;

{Metoda vraci minimum z dvou predanych hodnot}
function Minimum(a, b : Integer) : Integer;
begin
  If a < b then Result := a
  else Result := b;
end;

function ExportPoint: string;
var
  ShortExportLength2: integer;
  LongExportLength2:  integer; 
  i:                  integer;
  s:                  string;
  e:                  string;
  ExportLogsMaxcount: integer;
  UserCmt:            integer;
  Name:               string; 
  NameFinall:         string;
  Author:             string;
  ShortCmt:           string;
  Sym, wptSym:        string;
  ShortDescription:   string;
  LongDescription:    string;
  Hint:               string;
  FullName:           string;
  Waypoint1:          string;
  Waypoint2:          string;
  Waypoint3:          string;
  Waypoint4:          string;
  Waypoint5:          string;
  Waypoint6:          string;
  authorization:      boolean;
  wptCmt:             string;
  wptHint:            string;
begin
  // Po radnem vyplneni formulare
  if n = 1 then
  begin 
    // Pretypovani promenych z config souboru
    ShortExportLength2 := StrToInt(Trekbuddy_form_Edit1.Text);
    LongExportLength2  := StrToInt(Trekbuddy_form_Edit2.Text); 
    
    // Definice promenych
    case Trekbuddy_form_ComboBox1.ItemIndex of
      0: ExportLogsMaxcount := 0;
      1: ExportLogsMaxcount := 1;
      2: ExportLogsMaxcount := 5;
      3: ExportLogsMaxcount := 10;
      4: ExportLogsMaxcount := 20;
      5: ExportLogsMaxcount := GC.Logs.count;
    end;  

    // Definice promenych pro CMT
    case Trekbuddy_form_ComboBox2.ItemIndex of
      0: UserCmt := 1;
      1: UserCmt := 2;
      2: UserCmt := 3;
    end;  

    //Export for Geocaches
    if gc.islisted then
    begin
      // Prirazeni patricne ikony cache v TB 
      Sym := GC.TypeID;
      Sym := ReplaceString(Sym, 'T', '1');
      Sym := ReplaceString(Sym, 'M', '2');
      Sym := ReplaceString(Sym, 'U', '3');
      Sym := ReplaceString(Sym, 'G', '4');
      Sym := ReplaceString(Sym, 'H', '5');
      Sym := ReplaceString(Sym, 'I', '6');
      Sym := ReplaceString(Sym, 'V', '7');
      Sym := ReplaceString(Sym, 'W', '8');
      Sym := ReplaceString(Sym, 'E', '9');    
    
      // Uprava nazvu kesky (odstraneni HTML a nebezpecnych znaku)
      Name := ToAscii(GC.Name, Trekbuddy_form_CheckBox4.checked);

      // Konecna uprava nazvu kesky  
      NameFinall := Selection(Name, GC.IDTag, Trekbuddy_form_RadioGroup1.ItemIndex);
      if Trekbuddy_form_CheckBox1.checked = true then
        NameFinall := copy(NameFinall, 1, 30);      
      // Nick autora
      Author := ToAscii(GC.Author, Trekbuddy_form_CheckBox4.checked);
      
      //Zjisteni nadmorske vysky
      e := GC.TagValues('Elevation');
      if e = '' then
        e := '0.0';      
      
      // Oznaceni pro aktivitu kesky (disabled, archived)
      if GC.IsDisabled then
        s := 'available="False"'
      else
        s := 'available="True"';
      if GC.IsArchived then
        s := s + ' archived="True"'
      else
        s := s + ' archived="False"';
      s := 'id="' + GC.CacheID +'" ' + s;      
      
      //Uprava listingu pro odstraneni diakritiky a HTML tagu
      if Trekbuddy_form_CheckBox2.checked = true then begin
        ShortDescription := ToAscii(GC.ShortDescription, Trekbuddy_form_CheckBox4.checked);

      end
      else begin
        ShortDescription := '';

      end;

      // Dlouhy popis  
      if Trekbuddy_form_CheckBox3.checked = true then begin
        LongDescription := ToAscii(GC.LongDescription, Trekbuddy_form_CheckBox4.checked);
      end
      else begin
        LongDescription := '';
      end;

      // Uprava hintu
      Hint := ToAscii(GC.Hint, Trekbuddy_form_CheckBox4.checked);
      
      // Nastaveni komentare dle volby uzivatelu
      case Trekbuddy_form_ComboBox2.ItemIndex of
        0: ShortCmt := GC.IDTag;
        1: ShortCmt := 'Type: '+ GC.CacheType + ' | Size: '+ GC.Size +' | Diff: ' + GC.Difficulty + ' | Terr: ' + GC.Terrain + '';
        2: ShortCmt := 'Type: '+ GC.CacheType + ' | Size: '+ GC.Size +' | Diff: ' + GC.Difficulty + ' | Terr: ' + GC.Terrain + ' | Hint: ' + Hint + '';
      end; 
      
      // Orez listingu
      if ShortExportLength2 > 0 then
        ShortDescription := TrimToLength(ShortDescription,ShortExportLength2);
      if LongExportLength2 > 0 then
        LongDescription := TrimToLength(LongDescription,LongExportLength2);      

      // GPX struktura
      result := '';
      Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
      Result := Result + '  <time>'
                           + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + 
                         '</time>' + CRLF;
      Result := Result + '  <name><![CDATA[' + GC.ID + ']]></name>' + CRLF;
      Result := Result + '  <cmt><![CDATA[' + ShortCmt + ']]></cmt>' + CRLF;   
      Result := Result + '  <desc><![CDATA[' + Name + ' by ' + Author + ', ' + GC.CacheType + ' (' + GC.Difficulty + '/' + GC.Terrain + ')]]></desc>' + CRLF;
      Result := Result + '  <url><![CDATA[http://www.geocaching.com/seek/cache_details.aspx?wp=' + GC.ID + ']]></url>' + CRLF;
      Result := Result + '  <urlname><![CDATA[' + Name + ']]></urlname>' + CRLF;
      Result := Result + '  <ele><![CDATA[' + e + ']]></ele>' + CRLF;
      Result := Result + '  <sym><![CDATA[' + Sym + ']]></sym>' + CRLF;
      Result := Result + '  <type><![CDATA[Geocache|' + GC.CacheType + ']]></type>' + CRLF;
      Result := Result + '  <groundspeak:cache ' + s + ' xmlns:groundspeak="http://www.groundspeak.com/cache/1/0">' + CRLF;
      Result := Result + '   <groundspeak:name><![CDATA[' + NameFinall + ']]></groundspeak:name>' + CRLF;
      Result := Result + '   <groundspeak:placed_by><![CDATA[' + Author + ']]></groundspeak:placed_by>' + CRLF;
      Result := Result + '   <groundspeak:type><![CDATA[' + GC.CacheType + ']]></groundspeak:type>' + CRLF;
      Result := Result + '   <groundspeak:container><![CDATA[' + GC.Size + ']]></groundspeak:container>' + CRLF;
      Result := Result + '   <groundspeak:difficulty><![CDATA[' + GC.Difficulty + ']]></groundspeak:difficulty>' + CRLF;
      Result := Result + '   <groundspeak:terrain><![CDATA[' + GC.Terrain + ']]></groundspeak:terrain>' + CRLF;
      Result := Result + '   <groundspeak:country><![CDATA[' + GC.Country + ']]></groundspeak:country>' + CRLF;
      Result := Result + '   <groundspeak:state><![CDATA[' + GC.State + ']]></groundspeak:state>' + CRLF;
      Result := Result + '   <groundspeak:short_description html="False"><![CDATA[' + ShortDescription + ']]></groundspeak:short_description>' + CRLF;
      Result := Result + '   <groundspeak:long_description html="False"><![CDATA[' + LongDescription + ']]></groundspeak:long_description>' + CRLF;
      Result := Result + '   <groundspeak:encoded_hints><![CDATA[' + Hint + ']]></groundspeak:encoded_hints>' + CRLF;
      Result := Result + '   <groundspeak:logs>' + CRLF;
      
      // Vlozeni logu
      for i := 0 to Minimum(GC.Logs.count - 1, ExportLogsMaxcount-1) do
      begin
         Result := Result + ExportLog(GC.Logs[i].LogID,GC.Logs[i].LogType,GC.Logs[i].FinderID,GC.Logs[i].Finder,GC.Logs[i].Text,GC.Logs[i].Date);
      end;
      Result := Result + '   </groundspeak:logs>' + CRLF;    
      Result := Result + '  </groundspeak:cache>' + CRLF;
      Result := Result + ' </wpt>' + CRLF + CRLF;
    end;
    
    // Overeni zaskrtnuti vybranych waypointu
    if Trekbuddy_form_CheckBox5.checked = true then
      Waypoint1 := '+'; 
    if Trekbuddy_form_CheckBox6.checked = true then
      Waypoint2 := '-';
    if Trekbuddy_form_CheckBox7.checked = true then
      Waypoint3 := 'h';
    if Trekbuddy_form_CheckBox8.checked = true then
      Waypoint4 := 'k';   
    if Trekbuddy_form_CheckBox9.checked = true then
      Waypoint5 := 'm';     
    if Trekbuddy_form_CheckBox10.checked = true then
      Waypoint6 := 'p';    

    // Export  Waypoints
    for i := 0 to GC.Waypoints.Count - 1 do
      if GC.Waypoints[i].IsListed then
      begin
        // Prirazeni paricneho symbolu dle typu waypoint-u
        wptSym:= GC.Waypoints[i].TypeID;
        wptSym:= ReplaceString(wptSym, 'F', '+');
        wptSym:= ReplaceString(wptSym, 'P', '-');
        wptSym:= ReplaceString(wptSym, 'Q', 'h');    
        wptSym:= ReplaceString(wptSym, 'R', 'k');
        wptSym:= ReplaceString(wptSym, 'S', 'm');
        wptSym:= ReplaceString(wptSym, 'T', 'p');      
        
        if wptSym = Waypoint1 then
          authorization := true
        else if wptSym = Waypoint2 then  
          authorization := true
        else if wptSym = Waypoint3 then  
          authorization := true
        else if wptSym = Waypoint4 then  
          authorization := true
        else if wptSym = Waypoint5 then  
          authorization := true
        else if wptSym = Waypoint6 then  
          authorization := true
        else
          authorization := false;                                             
       
        // Pokud je dany Waypoint povoleny, tak jej vlozime do GPX
        if authorization = true then begin
          // Uprava nazvu waypoint-u(odstraneni HTML a nebezpecnych znaku)
          FullName := ToAscii(GC.Waypoints[i].FullName, Trekbuddy_form_CheckBox4.checked);

          if Trekbuddy_form_CheckBox1.checked = true then
            FullName := copy(FullName, 1, 30);       
       
          // Pro wypoint typu final pridame do tagu <cmt> jeste typ kese a obtiznosti
          if GC.Waypoints[i].TypeID = 'F' then
            wptCmt := '[' + GC.IDTag + '] ' + GC.Waypoints[i].Description +' | ' + GC.Waypoints[i].Comment + ''
          else
            wptCmt := '' + GC.Waypoints[i].Description +' ' + GC.Waypoints[i].Comment + '';       
          
          // Uprava pro odstraneni diakritiky a HTML tagu
          wptCmt := ToAscii(wptCmt, Trekbuddy_form_CheckBox4.checked);
       
          // Oznaceni pro aktivitu kesky (disabled, archived)
          if GC.IsDisabled then
            s := 'available="False"'
          else
            s := 'available="True"';

          if GC.IsArchived then
            s := s + ' archived="True"'
          else
            s := s + ' archived="False"';

          s := 'id="' + GC.CacheID +'" ' + s;       
        
          // Kdyz se jedna o waypoint typu finall, priradime promene hint obsah napovedy
          if GC.Waypoints[i].TypeID = 'F' then
            wptHint := Hint
          else
            wptHint := '';
        
          // GPX struktura
          Result := Result + ' <wpt lat="' + GC.Waypoints[i].Lat + '" lon="' + GC.Waypoints[i].Lon + '">' + CRLF;
          Result := Result + '  <time>'
            + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
          Result := Result + '  <name><![CDATA[' + FullName + ']]></name>' + CRLF;           
          Result := Result + '  <cmt><![CDATA[' + wptCmt + ']]></cmt>' + CRLF;
          Result := Result + '  <ele><![CDATA[0.0]]></ele>' + CRLF;
          Result := Result + '  <sym><![CDATA[' + wptSym + ']]></sym>' + CRLF;
          Result := Result + '  <type>Geocache|' + GC.CacheType + '</type>' + CRLF;
          Result := Result + '  <groundspeak:cache ' + s + ' xmlns:groundspeak="http://www.groundspeak.com/cache/1/0">' + CRLF;      
          Result := Result + '   <groundspeak:name><![CDATA[. [' + GC.Waypoints[i].TypeID + '] ' + FullName + ']]></groundspeak:name>' + CRLF;
          Result := Result + '   <groundspeak:type><![CDATA[' + GC.CacheType + ']]></groundspeak:type>' + CRLF;
          Result := Result + '   <groundspeak:container><![CDATA[' + GC.Size + ']]></groundspeak:container>' + CRLF;
          Result := Result + '   <groundspeak:difficulty><![CDATA[' + GC.Difficulty + ']]></groundspeak:difficulty>' + CRLF;
          Result := Result + '   <groundspeak:terrain><![CDATA[' + GC.Terrain + ']]></groundspeak:terrain>' + CRLF;
          Result := Result + '   <groundspeak:country><![CDATA[' + GC.Country + ']]></groundspeak:country>' + CRLF;
          Result := Result + '   <groundspeak:state><![CDATA[' + GC.State + ']]></groundspeak:state>' + CRLF;      
          Result := Result + '   <groundspeak:short_description html="True"></groundspeak:short_description>' + CRLF;
          Result := Result + '   <groundspeak:long_description html="True"></groundspeak:long_description>' + CRLF;
          Result := Result + '   <groundspeak:encoded_hints><![CDATA[' + wptHint + ']]></groundspeak:encoded_hints>' + CRLF;
          Result := Result + '  </groundspeak:cache>' + CRLF;
          Result := Result + ' </wpt>' + CRLF + CRLF; 
        end;     
      end;
  end;    
end;
